/* GCC */
#include <iostream>
#include <vector>
#include <sstream>
using namespace std;

vector< vector<int> > symmetries;
vector< vector<int> > colors;
bool used[25] = {false,};
bool connect[25][25];
vector<int> connections[25];
vector<int> hypotesis;

bool check_hypotesis(){
	for(int i = 0; i < hypotesis.size(); i++){
		if (connections[i].size() != connections[hypotesis[i]].size()) return false;
		for(int j = 0; j < hypotesis.size(); j++){
			if (connect[hypotesis[i]][hypotesis[j]] != connect[i][j]) return false;
		}
	}
	return true;
}

void generate_symmetries(int d){
  if (hypotesis.size() == d){
	symmetries.push_back(hypotesis);
	return;	
  }
  for(int i = 0; i < d; i++)
	  if (!used[i]){
		  hypotesis.push_back(i);
		  used[i] = true;
		  if (check_hypotesis()) generate_symmetries(d);
		  hypotesis.pop_back();
		  used[i] = false;
	  }
}


bool check_colors(){
	bool ok = false;
	for(int i = 0; i < symmetries.size(); i++){
		for(int j = 0; j < colors.size(); j++){
			ok = false;
			for(int t = 0; t < hypotesis.size(); t++){
				if (hypotesis[t] != colors[j][symmetries[i][t]]) ok = true;
			}
			if (!ok) return false;
		}
	}
	return true;
}
void generate_colors(int d, int m){
	if (hypotesis.size() == d){
		if (check_colors()) colors.push_back(hypotesis);
		return;
	}
	for(int i = 0; i < m; i++){
		hypotesis.push_back(i);
		generate_colors(d, m);
		hypotesis.pop_back();
	}
}
int main(){
	freopen("farben.in", "r", stdin);
	freopen("farben.out", "w", stdout);
	int m; cin>>m; int d = 0;
	for(int i = 0; i < 25; i++) for(int j = 0; j < 25; j++) connect[i][j] = false;
	while(cin){
		int l; cin>>l;
		connect[d][l-1] = connect[l-1][d] = true;
		connections[d].push_back(l-1);
		if( cin.get() == 10) d++;
	}
	vector<int> fsim;
	for(int i = 0; i < d; i++) fsim.push_back(i);
	symmetries.push_back(fsim);
	generate_symmetries(d);
	symmetries.erase(symmetries.begin());
	fsim.clear();
	hypotesis.clear();
    for(int i = 0; i < d; i++) fsim.push_back(0);
	colors.push_back(fsim);
	generate_colors(d, m);
	cout<<colors.size()<<endl;
}	