/* VC */ 

#include <fstream>
#include <vector>

int findLast(const std::vector<int>& arrive,int lex,int left,int right)
{
	if(arrive[left] >= lex)
		return left-1;
	if(left == right)
		return left;
	if(left == right-1)
	{
		if(arrive[right] < lex)
			return right;
		else 
			return left;
	}
	int middle = (left+right)/2;
	if(arrive[middle] >= lex)
		return findLast(arrive,lex,left,middle);
	if(arrive[middle] < lex)
		return findLast(arrive,lex,middle,right);
}

int main()
{
	std::ifstream in("clinic.in");
	int n,t1,t2;
	in >> n >> t1 >> t2;
	std::vector<int> arrive(n);
	std::vector<int> delay(n);
	for(int i = 0;i < arrive.size();i++)
		in >> arrive[i];
	for(int i = 0;i < delay.size();i++)
		in >> delay[i];
	in.close();
	std::vector<int> enter(n);
	enter[0] = std::max(arrive[0],t1);
	for(int i = 1;i < n;i++)
		enter[i] = enter[i-1] + delay[i-1];
	std::vector<int> wait(n);
	for(int i = 0;i < wait.size();i++)
		wait[i] = std::max(enter[i] - arrive[i],0);
	std::vector<int> leave(n);
	for(int i = 0;i < leave.size();i++)
		leave[i] = enter[i] + delay[i];
	unsigned int answer = -1;
	unsigned int time = -1;
	if(arrive[0] >= t1)
	{
		answer = t1;
		time = 0;
	}
	else
	{
		for(int i = 0;i < wait.size();i++)
		{
			if(wait[i] < time || ((wait[i] == time) && (arrive[i] < answer)))
			{
				answer = arrive[i];
				time = wait[i];
			}
		}
		int last = 0;
		for(int i = 0;i < leave.size();i++)
		{
			if(i == leave.size()-1)
			{
				if(leave[i] < t2)
				{
					if(time != 0)
					{
						time = 0;
						answer = leave[i];
					}
				}
			}
			else if(leave[last] < t2)
			{
				last = findLast(arrive,leave[i],i+1,arrive.size()-1);
				if(leave[last] < t2)
				{
					int temp = leave[last]-leave[i];
					if(temp < time || ((temp == time) && (leave[i] < answer)))
					{
						time = temp;
						answer = leave[i];
					}
				}
			}
		}
	}
	std::ofstream out("clinic.out");
	out << answer << std::endl;
	out.close();
}