/* VC */ 

#include <algorithm>
#include <fstream>
#include <vector>

struct Cmp
{
	int t;
	bool operator()(std::pair<int,int> x1,std::pair<int,int> x2)
	{
		return (x1.first - x1.second < x2.first - x2.second);
	}
	bool check(std::pair<int,int> x1,std::pair<int,int> x2)
	{
		return (x1.first < x2.first - t) && (x1.second > x2.second);
	}
};

int find(const std::vector<std::pair<int,int> >& number,Cmp cmp,int lex,int left,int right)
{
	if(!cmp.check(number[lex],number[right]))
		return number.size();
	if(left == right)
		return left;
	if(left == right-1)
	{
		if(cmp.check(number[lex],number[left]))
			return left;
		else
			return right;
	}
	int middle = (left+right+1)/2;
	if(cmp.check(number[lex],number[middle]))
		return find(number,cmp,lex,left,middle);
	else
		return find(number,cmp,lex,middle,right);
}

int main()
{
	std::ifstream in("inverses.in");
	int n,t;
	in >> n >> t;
	std::vector<std::pair<int,int> > number(n);
	for(int i = 0;i < number.size();i++)
	{
		int value;
		in >> value;
		number[i] = std::make_pair(value,i);
	}
	in.close();
	Cmp cmp;
	cmp.t = t;
	std::sort(number.begin(),number.end(),cmp);
	unsigned long long counter = 0;
	for(int i = 0;i < number.size()-1;i++)
	{
		int j = 0;
		j = number.size() - find(number,cmp,i,i+1,number.size()-1);
		counter += j;
	}
	std::ofstream out("inverses.out");
	out << counter << std::endl;
	out.close();
}